package userkindboxreqservice

import (
	"context"

	entity "git.gocasts.ir/ebhomengo/niki/entity"
	param "git.gocasts.ir/ebhomengo/niki/param/benefactor/kind_box_req"
	richerror "git.gocasts.ir/ebhomengo/niki/pkg/rich_error"
)

func (s Service) Update(ctx context.Context, req param.KindBoxReqUpdateRequest) (param.KindBoxReqUpdateResponse, error) {
	// TODO: can benefactor update its request ?
	// TODO: Is Update Mothod Service Responsible to check which kindboxreqID belongs to benefactorID ?
	const op = "userkindboxreqservice.Update"

	kindBoxReq, uErr := s.repo.UpdateKindBoxReq(ctx, req.KindBoxReqID, entity.KindBoxReq{
		BenefactorID:   req.BenefactorID,
		TypeID:         req.TypeID,
		CountRequested: req.CountRequested,
	})
	if uErr != nil {
		return param.KindBoxReqUpdateResponse{}, richerror.New(op).WithErr(uErr).WithKind(richerror.KindUnexpected)
	}

	return param.KindBoxReqUpdateResponse{KindBoxReq: kindBoxReq}, nil
}
